/**
 * This is a generated class and is not intended for modification.  To customize behavior
 * of this value object you may modify the generated sub-class of this class - Country.as.
 */

package valueObjects
{
import com.adobe.fiber.services.IFiberManagingService;
import com.adobe.fiber.util.FiberUtils;
import com.adobe.fiber.valueobjects.IValueObject;
import flash.events.Event;
import flash.events.EventDispatcher;
import mx.binding.utils.ChangeWatcher;
import mx.collections.ArrayCollection;
import mx.events.PropertyChangeEvent;
import mx.validators.ValidationResult;

import flash.net.registerClassAlias;
import flash.net.getClassByAlias;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;

use namespace model_internal;

[ExcludeClass]
public class _Super_Country extends flash.events.EventDispatcher implements com.adobe.fiber.valueobjects.IValueObject
{
    model_internal static function initRemoteClassAliasSingle(cz:Class) : void
    {
    }

    model_internal static function initRemoteClassAliasAllRelated() : void
    {
    }

    model_internal var _dminternal_model : _CountryEntityMetadata;
    model_internal var _changedObjects:mx.collections.ArrayCollection = new ArrayCollection();

    public function getChangedObjects() : Array
    {
        _changedObjects.addItemAt(this,0);
        return _changedObjects.source;
    }

    public function clearChangedObjects() : void
    {
        _changedObjects.removeAll();
    }

    /**
     * properties
     */
    private var _internal_icon : String;
    private var _internal_name : String;
    private var _internal_population : String;
    private var _internal_government : String;
    private var _internal_cap : String;
    private var _internal_flag : String;

    private static var emptyArray:Array = new Array();


    /**
     * derived property cache initialization
     */
    model_internal var _cacheInitialized_isValid:Boolean = false;

    model_internal var _changeWatcherArray:Array = new Array();

    public function _Super_Country()
    {
        _model = new _CountryEntityMetadata(this);

        // Bind to own data or source properties for cache invalidation triggering
        model_internal::_changeWatcherArray.push(mx.binding.utils.ChangeWatcher.watch(this, "icon", model_internal::setterListenerIcon));

    }

    /**
     * data/source property getters
     */

    [Bindable(event="propertyChange")]
    public function get icon() : String
    {
        return _internal_icon;
    }

    [Bindable(event="propertyChange")]
    public function get name() : String
    {
        return _internal_name;
    }

    [Bindable(event="propertyChange")]
    public function get population() : String
    {
        return _internal_population;
    }

    [Bindable(event="propertyChange")]
    public function get government() : String
    {
        return _internal_government;
    }

    [Bindable(event="propertyChange")]
    public function get cap() : String
    {
        return _internal_cap;
    }

    [Bindable(event="propertyChange")]
    public function get flag() : String
    {
        return _internal_flag;
    }

    public function clearAssociations() : void
    {
    }

    /**
     * data/source property setters
     */

    public function set icon(value:String) : void
    {
        var oldValue:String = _internal_icon;
        if (oldValue !== value)
        {
            _internal_icon = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "icon", oldValue, _internal_icon));
        }
    }

    public function set name(value:String) : void
    {
        var oldValue:String = _internal_name;
        if (oldValue !== value)
        {
            _internal_name = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "name", oldValue, _internal_name));
        }
    }

    public function set population(value:String) : void
    {
        var oldValue:String = _internal_population;
        if (oldValue !== value)
        {
            _internal_population = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "population", oldValue, _internal_population));
        }
    }

    public function set government(value:String) : void
    {
        var oldValue:String = _internal_government;
        if (oldValue !== value)
        {
            _internal_government = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "government", oldValue, _internal_government));
        }
    }

    public function set cap(value:String) : void
    {
        var oldValue:String = _internal_cap;
        if (oldValue !== value)
        {
            _internal_cap = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "cap", oldValue, _internal_cap));
        }
    }

    public function set flag(value:String) : void
    {
        var oldValue:String = _internal_flag;
        if (oldValue !== value)
        {
            _internal_flag = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "flag", oldValue, _internal_flag));
        }
    }

    /**
     * Data/source property setter listeners
     *
     * Each data property whose value affects other properties or the validity of the entity
     * needs to invalidate all previously calculated artifacts. These include:
     *  - any derived properties or constraints that reference the given data property.
     *  - any availability guards (variant expressions) that reference the given data property.
     *  - any style validations, message tokens or guards that reference the given data property.
     *  - the validity of the property (and the containing entity) if the given data property has a length restriction.
     *  - the validity of the property (and the containing entity) if the given data property is required.
     */

    model_internal function setterListenerIcon(value:flash.events.Event):void
    {
        _model.invalidateDependentOnIcon();
    }


    /**
     * valid related derived properties
     */
    model_internal var _isValid : Boolean;
    model_internal var _invalidConstraints:Array = new Array();
    model_internal var _validationFailureMessages:Array = new Array();

    /**
     * derived property calculators
     */

    /**
     * isValid calculator
     */
    model_internal function calculateIsValid():Boolean
    {
        var violatedConsts:Array = new Array();
        var validationFailureMessages:Array = new Array();

        var propertyValidity:Boolean = true;
        if (!_model.iconIsValid)
        {
            propertyValidity = false;
            com.adobe.fiber.util.FiberUtils.arrayAdd(validationFailureMessages, _model.model_internal::_iconValidationFailureMessages);
        }

        model_internal::_cacheInitialized_isValid = true;
        model_internal::invalidConstraints_der = violatedConsts;
        model_internal::validationFailureMessages_der = validationFailureMessages;
        return violatedConsts.length == 0 && propertyValidity;
    }

    /**
     * derived property setters
     */

    model_internal function set isValid_der(value:Boolean) : void
    {
        var oldValue:Boolean = model_internal::_isValid;
        if (oldValue !== value)
        {
            model_internal::_isValid = value;
            _model.model_internal::fireChangeEvent("isValid", oldValue, model_internal::_isValid);
        }
    }

    /**
     * derived property getters
     */

    [Transient]
    [Bindable(event="propertyChange")]
    public function get _model() : _CountryEntityMetadata
    {
        return model_internal::_dminternal_model;
    }

    public function set _model(value : _CountryEntityMetadata) : void
    {
        var oldValue : _CountryEntityMetadata = model_internal::_dminternal_model;
        if (oldValue !== value)
        {
            model_internal::_dminternal_model = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "_model", oldValue, model_internal::_dminternal_model));
        }
    }

    /**
     * methods
     */


    /**
     *  services
     */
    private var _managingService:com.adobe.fiber.services.IFiberManagingService;

    public function set managingService(managingService:com.adobe.fiber.services.IFiberManagingService):void
    {
        _managingService = managingService;
    }

    model_internal function set invalidConstraints_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_invalidConstraints;
        // avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_invalidConstraints = value;
            _model.model_internal::fireChangeEvent("invalidConstraints", oldValue, model_internal::_invalidConstraints);
        }
    }

    model_internal function set validationFailureMessages_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_validationFailureMessages;
        // avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_validationFailureMessages = value;
            _model.model_internal::fireChangeEvent("validationFailureMessages", oldValue, model_internal::_validationFailureMessages);
        }
    }

    model_internal var _doValidationCacheOfIcon : Array = null;
    model_internal var _doValidationLastValOfIcon : String;

    model_internal function _doValidationForIcon(valueIn:Object):Array
    {
        var value : String = valueIn as String;

        if (model_internal::_doValidationCacheOfIcon != null && model_internal::_doValidationLastValOfIcon == value)
           return model_internal::_doValidationCacheOfIcon ;

        _model.model_internal::_iconIsValidCacheInitialized = true;
        var validationFailures:Array = new Array();
        var errorMessage:String;
        var failure:Boolean;

        var valRes:ValidationResult;
        if (_model.isIconAvailable && _internal_icon == null)
        {
            validationFailures.push(new ValidationResult(true, "", "", "icon is required"));
        }

        model_internal::_doValidationCacheOfIcon = validationFailures;
        model_internal::_doValidationLastValOfIcon = value;

        return validationFailures;
    }
    

}

}
